
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega48P
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega48P
	#pragma AVRPART MEMORY PROG_FLASH 4096
	#pragma AVRPART MEMORY EEPROM 256
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _mona=R4
	.DEF _pos_read=R3
	.DEF _pos_write=R6

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

;GPIOR0 INITIALIZATION
	.EQU  __GPIOR0_INIT=0x00

_0x3:
	.DB  0x40,0x0,0x0,0x0,0x0,0x95

__GLOBAL_INI_TBL:
	.DW  0x06
	.DW  _CMD
	.DW  _0x3*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x2FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x2FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x180)
	LDI  R29,HIGH(0x180)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x180

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.03.4 Standard
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 23.11.2009
;Author  :
;Company :
;Comments:
;
;
;Chip type           : ATmega48P
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;External RAM size   : 0
;Data Stack size     : 128
;*****************************************************/
;
;#include <mega48p.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;#include "main.h"

	.DSEG
;#include "delay.h"
;char Buffer[256];
;unsigned char pos_read,pos_write;
;// Timer 1 overflow interrupt service routine
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 001E {

	.CSEG
_timer1_ovf_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 001F TCNT1H=0x0;
	LDI  R30,LOW(0)
	STS  133,R30
; 0000 0020 OCR1AL=Buffer[pos_read];
	MOV  R30,R3
	RCALL SUBOPT_0x0
	SUBI R30,LOW(-_Buffer)
	SBCI R31,HIGH(-_Buffer)
	LD   R30,Z
	STS  136,R30
; 0000 0021 pos_read++;
	INC  R3
; 0000 0022 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;// Timer 1 output compare A interrupt service routine
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 0026 {
_timer1_compa_isr:
; 0000 0027 // Place your code here
; 0000 0028 
; 0000 0029 }
	RETI
;
;
;
;void main(void)
; 0000 002E {
_main:
; 0000 002F // Declare your local variables here
; 0000 0030 
; 0000 0031 // Crystal Oscillator division factor: 1
; 0000 0032 #pragma optsize-
; 0000 0033 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 0034 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 0035 #ifdef _OPTIMIZE_SIZE_
; 0000 0036 #pragma optsize+
; 0000 0037 #endif
; 0000 0038 
; 0000 0039 // Input/Output Ports initialization
; 0000 003A // Port B initialization
; 0000 003B // Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=In
; 0000 003C // State7=T State6=T State5=0 State4=T State3=0 State2=0 State1=0 State0=T
; 0000 003D PORTB=0x00;
	OUT  0x5,R30
; 0000 003E DDRB=0x2F;
	LDI  R30,LOW(47)
	OUT  0x4,R30
; 0000 003F 
; 0000 0040 // Port C initialization
; 0000 0041 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0042 // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0043 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 0044 DDRC=0x00;
	OUT  0x7,R30
; 0000 0045 
; 0000 0046 // Port D initialization
; 0000 0047 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0048 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0049 PORTD=0x00;
	OUT  0xB,R30
; 0000 004A DDRD=0x00;
	OUT  0xA,R30
; 0000 004B 
; 0000 004C // Timer/Counter 0 initialization
; 0000 004D // Clock source: System Clock
; 0000 004E // Clock value: Timer 0 Stopped
; 0000 004F // Mode: Normal top=FFh
; 0000 0050 // OC0A output: Disconnected
; 0000 0051 // OC0B output: Disconnected
; 0000 0052 TCCR0A=0x00;
	OUT  0x24,R30
; 0000 0053 TCCR0B=0x00;
	OUT  0x25,R30
; 0000 0054 TCNT0=0x00;
	OUT  0x26,R30
; 0000 0055 OCR0A=0x00;
	OUT  0x27,R30
; 0000 0056 OCR0B=0x00;
	OUT  0x28,R30
; 0000 0057 
; 0000 0058 // Timer/Counter 1 initialization
; 0000 0059 // Clock source: System Clock
; 0000 005A // Clock value: 8000,000 kHz
; 0000 005B // Mode: Fast PWM top=00FFh
; 0000 005C // OC1A output: Non-Inv.
; 0000 005D // OC1B output: Discon.
; 0000 005E // Noise Canceler: Off
; 0000 005F // Input Capture on Falling Edge
; 0000 0060 // Timer 1 Overflow Interrupt: On
; 0000 0061 // Input Capture Interrupt: Off
; 0000 0062 // Compare A Match Interrupt: On
; 0000 0063 // Compare B Match Interrupt: Off
; 0000 0064 TCCR1A=0x81;
	LDI  R30,LOW(129)
	STS  128,R30
; 0000 0065 TCCR1B=0x09;
	LDI  R30,LOW(9)
	STS  129,R30
; 0000 0066 TCNT1H=0x00;
	LDI  R30,LOW(0)
	STS  133,R30
; 0000 0067 TCNT1L=0x00;
	STS  132,R30
; 0000 0068 ICR1H=0x00;
	STS  135,R30
; 0000 0069 ICR1L=0x00;
	STS  134,R30
; 0000 006A OCR1AH=0x00;
	STS  137,R30
; 0000 006B OCR1AL=0x00;
	STS  136,R30
; 0000 006C OCR1BH=0x00;
	STS  139,R30
; 0000 006D OCR1BL=0x00;
	STS  138,R30
; 0000 006E 
; 0000 006F // Timer/Counter 2 initialization
; 0000 0070 // Clock source: System Clock
; 0000 0071 // Clock value: Timer 2 Stopped
; 0000 0072 // Mode: Normal top=FFh
; 0000 0073 // OC2A output: Disconnected
; 0000 0074 // OC2B output: Disconnected
; 0000 0075 ASSR=0x00;
	STS  182,R30
; 0000 0076 TCCR2A=0x00;
	STS  176,R30
; 0000 0077 TCCR2B=0x00;
	STS  177,R30
; 0000 0078 TCNT2=0x00;
	STS  178,R30
; 0000 0079 OCR2A=0x00;
	STS  179,R30
; 0000 007A OCR2B=0x00;
	STS  180,R30
; 0000 007B 
; 0000 007C // External Interrupt(s) initialization
; 0000 007D // INT0: Off
; 0000 007E // INT1: Off
; 0000 007F // Interrupt on any change on pins PCINT0-7: Off
; 0000 0080 // Interrupt on any change on pins PCINT8-14: Off
; 0000 0081 // Interrupt on any change on pins PCINT16-23: Off
; 0000 0082 EICRA=0x00;
	STS  105,R30
; 0000 0083 EIMSK=0x00;
	OUT  0x1D,R30
; 0000 0084 PCICR=0x00;
	STS  104,R30
; 0000 0085 
; 0000 0086 // Timer/Counter 0 Interrupt(s) initialization
; 0000 0087 TIMSK0=0x00;
	STS  110,R30
; 0000 0088 // Timer/Counter 1 Interrupt(s) initialization
; 0000 0089 TIMSK1=0x03;
	LDI  R30,LOW(3)
	STS  111,R30
; 0000 008A // Timer/Counter 2 Interrupt(s) initialization
; 0000 008B TIMSK2=0x00;
	LDI  R30,LOW(0)
	STS  112,R30
; 0000 008C 
; 0000 008D // Analog Comparator initialization
; 0000 008E // Analog Comparator: Off
; 0000 008F // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0090 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
; 0000 0091 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
; 0000 0092 
; 0000 0093 // SPI initialization
; 0000 0094 // SPI Type: Master
; 0000 0095 // SPI Clock Rate: 500,000 kHz
; 0000 0096 // SPI Clock Phase: Cycle Half
; 0000 0097 // SPI Clock Polarity: Low
; 0000 0098 // SPI Data Order: MSB First
; 0000 0099 SPCR=0x51;
	LDI  R30,LOW(81)
	OUT  0x2C,R30
; 0000 009A SPSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 009B 
; 0000 009C // Global enable interrupts
; 0000 009D #asm("sei")
	sei
; 0000 009E 
; 0000 009F do{
_0x5:
; 0000 00A0 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x1
	RCALL _delay_ms
; 0000 00A1 }while (mmc_init() != 0);
	RCALL _mmc_init
	CPI  R30,0
	BRNE _0x5
; 0000 00A2 t.all=offst;
	__GETD1N 0x41000
	RCALL SUBOPT_0x2
; 0000 00A3 mmc_read_potok (t.all,nsek);
	LDS  R30,_t
	LDS  R31,_t+1
	LDS  R22,_t+2
	LDS  R23,_t+3
	RCALL __PUTPARD1
	LDI  R30,LOW(119)
	LDI  R31,HIGH(119)
	RCALL SUBOPT_0x1
	RCALL _mmc_read_potok
; 0000 00A4 
; 0000 00A5 
; 0000 00A6 while (1)
_0x7:
; 0000 00A7       {
; 0000 00A8       // Place your code here
; 0000 00A9 #asm("wdr");
	wdr
; 0000 00AA       };
	RJMP _0x7
; 0000 00AB }
_0xA:
	RJMP _0xA
;unsigned char mmc_write_command (unsigned char *cmd)
; 0000 00AD {
_mmc_write_command:
; 0000 00AE 	unsigned char tmp = 0xff;
; 0000 00AF 	unsigned char a;
; 0000 00B0 	unsigned int Timeout = 0;
; 0000 00B1 
; 0000 00B2 	mmc_dis();
	RCALL __SAVELOCR4
;	*cmd -> Y+4
;	tmp -> R17
;	a -> R16
;	Timeout -> R18,R19
	LDI  R17,255
	RCALL SUBOPT_0x3
; 0000 00B3 	mmc_write_byte(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _mmc_write_byte
; 0000 00B4 	mmc_en();
	RCALL SUBOPT_0x4
	ANDI R30,LOW(0xFFFE)
	OUT  0x5,R30
; 0000 00B5 	for ( a = 0;a<0x06;a++) //
	LDI  R16,LOW(0)
_0xC:
	CPI  R16,6
	BRSH _0xD
; 0000 00B6 		{
; 0000 00B7 		mmc_write_byte(cmd[a]);
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	RCALL _mmc_write_byte
; 0000 00B8 		}
	SUBI R16,-1
	RJMP _0xC
_0xD:
; 0000 00B9 
; 0000 00BA 	while (tmp == 0xff)
_0xE:
	CPI  R17,255
	BRNE _0x10
; 0000 00BB 		{
; 0000 00BC 		tmp = mmc_read_byte();//     
	RCALL _mmc_read_byte
	MOV  R17,R30
; 0000 00BD 		if (Timeout++ > 500) //    
	RCALL SUBOPT_0x5
	CPI  R26,LOW(0x1F5)
	LDI  R30,HIGH(0x1F5)
	CPC  R27,R30
	BRLO _0xE
; 0000 00BE 			{
; 0000 00BF 			break; //
; 0000 00C0 			}
; 0000 00C1 		}
_0x10:
; 0000 00C2 	return(tmp); //
	MOV  R30,R17
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
; 0000 00C3 }
;//-------------------------------------------------------------------------
;  unsigned char mmc_read_byte()
; 0000 00C6    {
_mmc_read_byte:
; 0000 00C7   SPDR = 0x00;
	LDI  R30,LOW(0)
	OUT  0x2E,R30
; 0000 00C8  while(!(SPSR & (1<<SPIF))){ };
_0x12:
	IN   R30,0x2D
	RCALL SUBOPT_0x0
	ANDI R30,LOW(0x80)
	BREQ _0x12
; 0000 00C9  return SPDR;
	IN   R30,0x2E
	RET
; 0000 00CA  }
;//--------------------------------------------------------
;//-------------------------------------------------
;unsigned char mmc_init (void)
; 0000 00CE {
_mmc_init:
; 0000 00CF unsigned char b;
; 0000 00D0 unsigned int Timeout = 0;
; 0000 00D1 mmc_dis();
	RCALL __SAVELOCR4
;	b -> R17
;	Timeout -> R18,R19
	RCALL SUBOPT_0x3
; 0000 00D2 
; 0000 00D3 	for ( b = 0;b<0x0f;b++) //
	LDI  R17,LOW(0)
_0x16:
	CPI  R17,15
	BRSH _0x17
; 0000 00D4 		{
; 0000 00D5 		mmc_write_byte(0xff);
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _mmc_write_byte
; 0000 00D6 		}
	SUBI R17,-1
	RJMP _0x16
_0x17:
; 0000 00D7 //--------------------------------------------------
; 0000 00D8 	while(mmc_write_command (CMD) !=1)//  040 -       01
_0x18:
	RCALL SUBOPT_0x6
	CPI  R30,LOW(0x1)
	BREQ _0x1A
; 0000 00D9 	{
; 0000 00DA 		if (Timeout++ > 200)
	RCALL SUBOPT_0x5
	CPI  R26,LOW(0xC9)
	LDI  R30,HIGH(0xC9)
	CPC  R27,R30
	BRLO _0x1B
; 0000 00DB 			{
; 0000 00DC 			mmc_dis();
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
; 0000 00DD 			return(1);
	LDI  R30,LOW(1)
	RJMP _0x2000001
; 0000 00DE 			}
; 0000 00DF 	}
_0x1B:
	RJMP _0x18
_0x1A:
; 0000 00E0 	//----------------------------------------------
; 0000 00E1 
; 0000 00E2 	Timeout = 0;
	__GETWRN 18,19,0
; 0000 00E3 	CMD[0] = 0x41;//Commando 1// 041 -     00
	LDI  R30,LOW(65)
	STS  _CMD,R30
; 0000 00E4 	CMD[5] = 0xFF;
	RCALL SUBOPT_0x8
; 0000 00E5 	while( mmc_write_command (CMD) !=0)
_0x1C:
	RCALL SUBOPT_0x6
	CPI  R30,0
	BREQ _0x1E
; 0000 00E6 	{
; 0000 00E7 		if (Timeout++ > 400)
	RCALL SUBOPT_0x5
	CPI  R26,LOW(0x191)
	LDI  R30,HIGH(0x191)
	CPC  R27,R30
	BRLO _0x1F
; 0000 00E8 			{
; 0000 00E9 	                mmc_dis();
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
; 0000 00EA 			return(2);
	LDI  R30,LOW(2)
	RJMP _0x2000001
; 0000 00EB 			}
; 0000 00EC 	}
_0x1F:
	RJMP _0x1C
_0x1E:
; 0000 00ED 	mmc_dis();
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
; 0000 00EE 	return(0);
	LDI  R30,LOW(0)
_0x2000001:
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
; 0000 00EF }
;//---------------------------------------------------------------------
; //---------------------------------------------------------------------
;void mmc_read_potok (unsigned long addr,unsigned int sektor)
; 0000 00F3 {
_mmc_read_potok:
; 0000 00F4 
; 0000 00F5 unsigned int i;
; 0000 00F6 unsigned int sek_read=0;
; 0000 00F7 pos_read=0;
	RCALL __SAVELOCR4
;	addr -> Y+6
;	sektor -> Y+4
;	i -> R16,R17
;	sek_read -> R18,R19
	__GETWRN 18,19,0
	CLR  R3
; 0000 00F8 pos_write=0;
	CLR  R6
; 0000 00F9 t.all=addr;
	__GETD1S 6
	RCALL SUBOPT_0x2
; 0000 00FA CMD[0]=0x52; //     18
	LDI  R30,LOW(82)
	STS  _CMD,R30
; 0000 00FB CMD[1]=t.st.AdrHhi;  // 040 + 012
	__GETB1MN _t,3
	__PUTB1MN _CMD,1
; 0000 00FC CMD[2]=t.st.AdrHlo;
	__GETB1MN _t,2
	__PUTB1MN _CMD,2
; 0000 00FD CMD[3]=t.st.AdrLhi;
	__GETB1MN _t,1
	__PUTB1MN _CMD,3
; 0000 00FE CMD[4]=t.st.AdrLlo;
	LDS  R30,_t
	__PUTB1MN _CMD,4
; 0000 00FF CMD[5]=0xFF;
	RCALL SUBOPT_0x8
; 0000 0100 mmc_write_command (CMD); //  
	RCALL SUBOPT_0x6
; 0000 0101 
; 0000 0102 
; 0000 0103 do{
_0x21:
; 0000 0104 while (mmc_read_byte() != 0xfe){};//   
_0x23:
	RCALL _mmc_read_byte
	CPI  R30,LOW(0xFE)
	BRNE _0x23
; 0000 0105 	for ( i=0;i<512;i++)
	__GETWRN 16,17,0
_0x27:
	__CPWRN 16,17,512
	BRSH _0x28
; 0000 0106 		{
; 0000 0107         pos_write++;
	INC  R6
; 0000 0108         while(!(pos_read ^ pos_write));
_0x29:
	MOV  R26,R3
	CLR  R27
	MOV  R30,R6
	RCALL SUBOPT_0x0
	EOR  R30,R26
	EOR  R31,R27
	SBIW R30,0
	BREQ _0x29
; 0000 0109         Buffer[pos_write]=	mmc_read_byte();
	MOV  R30,R6
	RCALL SUBOPT_0x0
	SUBI R30,LOW(-_Buffer)
	SBCI R31,HIGH(-_Buffer)
	PUSH R31
	PUSH R30
	RCALL _mmc_read_byte
	POP  R26
	POP  R27
	ST   X,R30
; 0000 010A 		}
	__ADDWRN 16,17,1
	RJMP _0x27
_0x28:
; 0000 010B 	mmc_read_byte();//CRC
	RCALL _mmc_read_byte
; 0000 010C 	mmc_read_byte();//CRC
	RCALL _mmc_read_byte
; 0000 010D 			sek_read++;
	__ADDWRN 18,19,1
; 0000 010E }while(sek_read != sektor);
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x21
; 0000 010F 
; 0000 0110 //  
; 0000 0111 CMD[0]=0x4C; //    12
	LDI  R30,LOW(76)
	STS  _CMD,R30
; 0000 0112 CMD[1]=0;  // 040 + 00
	LDI  R30,LOW(0)
	__PUTB1MN _CMD,1
; 0000 0113 CMD[2]=0;
	__PUTB1MN _CMD,2
; 0000 0114 CMD[3]=0;
	__PUTB1MN _CMD,3
; 0000 0115 CMD[4]=0;
	__PUTB1MN _CMD,4
; 0000 0116 CMD[5]=0xFF;
	RCALL SUBOPT_0x8
; 0000 0117 mmc_write_command (CMD); //  
	RCALL SUBOPT_0x6
; 0000 0118 	mmc_dis();
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
; 0000 0119 }
	RCALL __LOADLOCR4
	ADIW R28,10
	RET
;//-----------------------------------------------
;void mmc_write_byte(unsigned char X)
; 0000 011C {
_mmc_write_byte:
; 0000 011D  SPDR=X;
;	X -> Y+0
	LD   R30,Y
	OUT  0x2E,R30
; 0000 011E    while (!(SPSR &(1<< SPIF)));
_0x2C:
	IN   R30,0x2D
	RCALL SUBOPT_0x0
	ANDI R30,LOW(0x80)
	BREQ _0x2C
; 0000 011F }
	ADIW R28,1
	RET
;//---------------------------------------------

	.DSEG
_t:
	.BYTE 0x4
_CMD:
	.BYTE 0x6
_Buffer:
	.BYTE 0x100

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x0:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2:
	STS  _t,R30
	STS  _t+1,R31
	STS  _t+2,R22
	STS  _t+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	__GETWRN 18,19,0
	IN   R30,0x5
	RCALL SUBOPT_0x0
	ORI  R30,1
	OUT  0x5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	IN   R30,0x5
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	MOVW R26,R18
	__ADDWRN 18,19,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(_CMD)
	LDI  R31,HIGH(_CMD)
	RCALL SUBOPT_0x1
	RJMP _mmc_write_command

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	ORI  R30,1
	OUT  0x5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(255)
	__PUTB1MN _CMD,5
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
