
#pragma used+
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0x21;   
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
#endasm

typedef  union
{
struct {
unsigned char AdrLlo ;
unsigned char AdrLhi ;
unsigned char AdrHlo ;
unsigned char AdrHhi ;
}st;
unsigned long all;
}tun;
tun t;
unsigned char mona;

unsigned char CMD[] = {0x40,0x00,0x00,0x00,0x00,0x95};    
unsigned char mmc_read_byte();
unsigned char mmc_write_command (unsigned char *cmd);
unsigned char mmc_init (void);
void mmc_read_potok (unsigned long addr,unsigned int sektor);
void mmc_write_byte(unsigned char X); 

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

char Buffer[256];
unsigned char pos_read,pos_write;

interrupt [14] void timer1_ovf_isr(void)
{
(*(unsigned char *) 0x85)=0x0;
(*(unsigned char *) 0x88)=Buffer[pos_read];
pos_read++;
}

interrupt [12] void timer1_compa_isr(void)
{

}

void main(void)
{

#pragma optsize-
(*(unsigned char *) 0x61)=0x80;
(*(unsigned char *) 0x61)=0x00;
#pragma optsize+

PORTB=0x00;
DDRB=0x2F;

PORTC=0x00;
DDRC=0x00;

PORTD=0x00;
DDRD=0x00;

TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

(*(unsigned char *) 0x80)=0x81;
(*(unsigned char *) 0x81)=0x09;
(*(unsigned char *) 0x85)=0x00;
(*(unsigned char *) 0x84)=0x00;
(*(unsigned char *) 0x87)=0x00;
(*(unsigned char *) 0x86)=0x00;
(*(unsigned char *) 0x89)=0x00;
(*(unsigned char *) 0x88)=0x00;
(*(unsigned char *) 0x8b)=0x00;
(*(unsigned char *) 0x8a)=0x00;

(*(unsigned char *) 0xb6)=0x00;
(*(unsigned char *) 0xb0)=0x00;
(*(unsigned char *) 0xb1)=0x00;
(*(unsigned char *) 0xb2)=0x00;
(*(unsigned char *) 0xb3)=0x00;
(*(unsigned char *) 0xb4)=0x00;

(*(unsigned char *) 0x69)=0x00;
EIMSK=0x00;
(*(unsigned char *) 0x68)=0x00;

(*(unsigned char *) 0x6e)=0x00;

(*(unsigned char *) 0x6f)=0x03;

(*(unsigned char *) 0x70)=0x00;

ACSR=0x80;
(*(unsigned char *) 0x7b)=0x00;

SPCR=0x51;
SPSR=0x00;

#asm("sei")

do{
delay_ms(10);
}while (mmc_init() != 0);
t.all=0x41000 ;
mmc_read_potok (t.all,61000 /512 ); 

while (1)
{

#asm("wdr");
};
}
unsigned char mmc_write_command (unsigned char *cmd)
{
unsigned char tmp = 0xff;
unsigned char a;
unsigned int Timeout = 0; 

((PORTB) |= 1 << (0))   ;
mmc_write_byte(0xFF);
((PORTB) &= ~(1 << (0))) ;
for ( a = 0;a<0x06;a++) 
{
mmc_write_byte(cmd[a]);
}

while (tmp == 0xff)	
{
tmp = mmc_read_byte();
if (Timeout++ > 500) 
{
break; 
}
}
return(tmp); 
}

unsigned char mmc_read_byte()
{
SPDR = 0x00; 
while(!(SPSR & (1<<7))){ };
return SPDR;
}

unsigned char mmc_init (void)
{
unsigned char b;
unsigned int Timeout = 0;
((PORTB) |= 1 << (0))   ;

for ( b = 0;b<0x0f;b++) 
{
mmc_write_byte(0xff);
}

while(mmc_write_command (CMD) !=1)
{
if (Timeout++ > 200)
{
((PORTB) |= 1 << (0))   ;
return(1); 
}
}

Timeout = 0;
CMD[0] = 0x41;
CMD[5] = 0xFF;
while( mmc_write_command (CMD) !=0)
{
if (Timeout++ > 400)
{
((PORTB) |= 1 << (0))   ;
return(2); 
}
}
((PORTB) |= 1 << (0))   ;
return(0);
}

void mmc_read_potok (unsigned long addr,unsigned int sektor)
{

unsigned int i;
unsigned int sek_read=0;
pos_read=0;
pos_write=0;
t.all=addr;
CMD[0]=0x52; 
CMD[1]=t.st.AdrHhi;  
CMD[2]=t.st.AdrHlo;
CMD[3]=t.st.AdrLhi;
CMD[4]=t.st.AdrLlo;
CMD[5]=0xFF;
mmc_write_command (CMD); 

do{
while (mmc_read_byte() != 0xfe){};
for ( i=0;i<512;i++)
{
pos_write++;
while(!(pos_read ^ pos_write));
Buffer[pos_write]=	mmc_read_byte();
}
mmc_read_byte();
mmc_read_byte();
sek_read++;
}while(sek_read != sektor);

CMD[0]=0x4C; 
CMD[1]=0;  
CMD[2]=0;
CMD[3]=0;
CMD[4]=0;
CMD[5]=0xFF;
mmc_write_command (CMD); 
((PORTB) |= 1 << (0))   ;
}	

void mmc_write_byte(unsigned char X) 
{   
SPDR=X;
while (!(SPSR &(1<< 7)));
}

